#include	"stdThread.h"

#ifdef _MSC_VER			// WindowŝƂ
#define DISABLE_C4996   __pragma(warning(push)) __pragma(warning(disable:4996))
#define ENABLE_C4996    __pragma(warning(pop))
#else					// Linux̂Ƃ
#define DISABLE_C4996
#define ENABLE_C4996
#endif


void GetHostName();
void GetHostAddress(LPSTR pszCurHost, LPSTR pszServ);



int main(int argc, char *argv[])
{
	int		iRet = -1;
	LPSTR	pszCurHost = NULL, pszServ = NULL;

	if (argc == 2)
		pszCurHost = argv[1];
	else if (argc == 3)
	{
		pszCurHost = argv[1];
		pszServ = argv[2];
	}

	GetHostName();
	GetHostAddress(pszCurHost, pszServ);

	iRet = 0;

	return(iRet);
}


//----------------------------------------------
// function
//    [JzXg̎擾
// parameter
//    Ȃ
// retun
//    Ȃ
//----------------------------------------------
void GetHostName()
{
	char	szHostName[NI_MAXHOST];		// zXgi[GA
	char	szMsg[NI_MAXHOST];

	// [JzXg̎擾
	DISABLE_C4996
		if (gethostname(szHostName, sizeof(szHostName)) == SOCKET_ERROR)
			sprintf(szMsg, "Err: %d", errno);
		else
			sprintf(szMsg, "%s", szHostName);
	ENABLE_C4996
		fprintf(stderr, "%s\n", szMsg);
}

//----------------------------------------------
// function
//		zXgIPAhX擾
//		zXgNULL̂Ƃ̓[JzXggp
// parameter
//		LPSTR		pszCurHost	[in]zXg/NULL
//		LPSTR		pszServ		[in]T[rX/NULL
// retun
//    Ȃ
//----------------------------------------------
void GetHostAddress(LPSTR pszCurHost, LPSTR pszServ)
{
	char		szHostName[NI_MAXHOST];
	addrinfo	hints, *pres = NULL, *pTemp = NULL;
	char		szHostAddr[NI_MAXHOST], szServPort[NI_MAXSERV];
	int			iCount = 1;

	// zXgszHostNameɊi[
	if (pszCurHost != NULL)
	{
		DISABLE_C4996
			strcpy(szHostName, pszCurHost);
		ENABLE_C4996
	}
	else
	{
		if (gethostname(szHostName, sizeof(szHostName)) == SOCKET_ERROR)
			goto L_END;
	}
	// hints̏
	memset(&hints, 0, sizeof(hints));
	hints.ai_family = AF_UNSPEC;

	if (getaddrinfo(szHostName, pszServ, &hints, &pres) != 0)
		goto L_END;

	// Ԃpres̒Ɋi[Ă\
	pTemp = pres;
	while (pTemp != NULL)
	{
		if (pszServ != NULL)
		{
			// NI_NUMERICHOST l`̃zXg NI_NUMERICSERV |[gԍ
			if (getnameinfo(pTemp->ai_addr, (socklen_t)pTemp->ai_addrlen, szHostAddr, sizeof(szHostAddr), szServPort, sizeof(szServPort), NI_NUMERICHOST | NI_NUMERICSERV) == 0)
			{
				fprintf(stderr, "%d family:%2d Address:%s Port:%s\n", iCount, pTemp->ai_family, szHostAddr, szServPort);
			}
		}
		else
		{
			// NI_NUMERICHOST l`̃zXg
			if (getnameinfo(pTemp->ai_addr, (socklen_t)pTemp->ai_addrlen, szHostAddr, sizeof(szHostAddr), NULL, 0, NI_NUMERICHOST) == 0)
			{
				fprintf(stderr, "%d family:%2d Address:%s\n", iCount, pTemp->ai_family, szHostAddr);
			}
		}
		pTemp = pTemp->ai_next;
		iCount++;
	}
	freeaddrinfo(pres);
L_END:
	return;
}

